<?php

namespace App\Exceptions;

use App\Helper\MemoryHelper;
use Exception;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\GuzzleException;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Illuminate\Support\Facades\Log;
use Illuminate\Validation\ValidationException;
use Symfony\Component\HttpFoundation\Exception\BadRequestException;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * A list of the exception types that are not reported.
     *
     * @var array<int, class-string<Throwable>>
     */
    protected $dontReport = [
        //
    ];

    /**
     * A list of the inputs that are never flashed for validation exceptions.
     *
     * @var array<int, string>
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Register the exception handling callbacks for the application.
     *
     * @return void
     */
    public function register()
    {
        $this->reportable(function (Throwable $e) {


        });
    }


    public function report(Throwable $exception)
    {
        if ($this->shouldReport($exception)) {
            // Gửi thông tin lỗi qua Telegram
            if ('APP_ENV' == 'production') {
                $this->sendTelegramMessage($exception);
            }

            // Log lỗi vào file
            Log::error($exception);
        }

        parent::report($exception); // TODO: Change the autogenerated stub
    }

    /**
     * @throws GuzzleException
     */
    private function sendTelegramMessage(Throwable $exception): void
    {
        $telegramToken = '5934799968:AAHVY34VQY-CsgFT-WXRym4NheUOkjp3uAs';
        $chatId = '5642237695';

        $client = new Client();

        $response = $client->post("https://api.telegram.org/bot{$telegramToken}/sendMessage", [
            'json' => [
                'chat_id' => $chatId,
                'text' => "Lỗi mới:\n" . $exception->getCode() . ":\n" . $exception->getMessage() . "\nFile: " . $exception->getFile() . "\nLine: " . $exception->getLine(),
            ],
        ]);
    }

    public function render($request, Throwable $e)
    {
        if (MemoryHelper::$is_frontend == 0) {
            return parent::render($request, $e); // TODO: Change the autogenerated stub
        }

        if ($e instanceof BadRequestException) {
            return response()->json([
                'message' => $e->getMessage(),
            ], 400);
        }

        return parent::render($request, $e); // TODO: Change the autogenerated stub
    }
}
